#include "horde_log.h"
#include "ippc_server.h"
#include "syscall.h"

#include <nmstl/ioevent>

#include <iostream>

using namespace horde;
using namespace std;
using namespace nmstl;

io_event_loop ioloop;

void recv_handler(ippc_handler* ioh, int type,char* msg, size_t len) {
  cerr << "RECV event: type=" << type << ", len=" << len << endl;

  if (type == IPPC_PING) {
    ippcmsg_pingpong* ping = (ippcmsg_pingpong*)msg;
    cerr << "PING: " << ping->seq << endl;
    
    ioh->send_message(IPPC_PONG, ping, len);
  } else {
    cerr << "\tBAD IPPC code.\n";
    ippcmsg_exception ex(type, "unexpected IPPC code, only IPPC_PING is supported");
    ioh->send_message(IPPC_EXCEPTION, &ex, sizeof(ex));
  }
}

void close_handler(ippc_handler* ioh) {
  cerr << "CLOSE event: " << ((ioh == NULL) ? "server" : "client") << endl;

  if (ioh == NULL) exit();
}


int main(void) {
  logging_init("test_pongserver", "/var/horde");

  unlink("/tmp/test.ippc");
  ippc_server server(ioloop, "/tmp/test.ippc", recv_handler, close_handler);

  ioloop.run();
}
