#include "horde_log.h"
#include "ippc_server.h"
#include "syscall.h"

#include <nmstl/ioevent>

#include <iostream>

using namespace horde;
using namespace std;
using namespace nmstl;

io_event_loop ioloop;

void recv_handler(ippc_handler* ioh, int type,char* msg, size_t len) {
  cerr << "RECV event: type=" << type << ", len=" << len << endl;

  if (type == IPPC_SEND_DATA) {
    // test received data
    ippcmsg_send_data* r = (ippcmsg_send_data*)msg;
    int* jarr = (int*)r->data;
    
    int n = *jarr;
    int miss=0;
    for (int i = 0; i < n-1; i++) {
      if (jarr[i+1] != r->adu_id+i) {
	miss++;
      }
    }
    
    printf("SEND_DATA: hstream=%d, adu_id=%d, miss=%d, [%d, %d, %d, %d, ..., %d, %d, %d]\n",
	   r->hstream, r->adu_id, miss,
	   jarr[0], jarr[1], jarr[2], jarr[3], jarr[n-4], jarr[n-3], jarr[n-2]);

    int seq = r->adu_id;

    // send back a recv_data event...
    char send_buf[1024];
    ippcmsg_recv_data* m = (ippcmsg_recv_data*)send_buf;
    int* arr = (int*)m->data;
    
    arr[0] = 6;
    arr[1] = seq;
    arr[2] = seq+1;
    arr[3] = seq+2;
    arr[4] = seq+3;
    arr[5] = seq+4;
    arr[6] = seq+5;

    m->hstream = 1;
    m->adu_id = seq;
    m->frag_start = seq;

    ioh->send_message(IPPC_RECV_DATA, m, sizeof(ippcmsg_recv_data) + sizeof(int)*7 - 1);

  } else {
    cerr << "\tBAD IPPC code.\n";
    ippcmsg_exception ex(type, "unexpected IPPC code, only IPPC_PING is supported");
    ioh->send_message(IPPC_EXCEPTION, &ex, sizeof(ex));
  }
}

void close_handler(ippc_handler* ioh) {
  cerr << "CLOSE event: " << ((ioh == NULL) ? "server" : "client") << endl;

  if (ioh == NULL) exit();
}


int main(void) {
  logging_init("test_pongserver", "/var/horde");

  unlink("/tmp/test.ippc");
  ippc_server server(ioloop, "/tmp/test.ippc", recv_handler, close_handler);

  ioloop.run();
}
