#!/bin/bash

#
# Creates the correct directory structure for a horde
# daemon's pipe-namespace and logs.
#
# usage: horde_dir_setup.sh <base> <ownership>
# effect: creates the following directories and makes 
#         it so that those directories are owned by
#         the given owner and group.
#
# base
# base/logs
# base/logs/event
# base/logs/net
# base/sessions
#

if [[ $# < 2 ]]
then  echo "correct usage: $0 [base directory] [owner user | user:group]"
      exit
fi

base=$1
owner=$2

create_dir() {
 dir=$1
 echo + creating: $dir
 mkdir $dir
 chown $owner $dir
}

echo "Creating horde directory tree: $base (ownership: $owner)"
create_dir $base
create_dir $base/logs
create_dir $base/logs/event
create_dir $base/logs/net
create_dir $base/sessions

