import horde_api
import sys

SESSION_NAME = "multiple"

nstreams = 16
stream_ids = ["stream:"+str(x) for x in range(nstreams)]
handles = [None] * nstreams

def do_client(server):
    if (horde_api.session_connect(server, SESSION_NAME)):
        print "connected to server '%s'." % server
        n = horde_api.stream_connect_multiple(nstreams, stream_ids, handles)
        print "connected:", n
        if (n > 0):
            for i in range(nstreams):
                print "%02d:\t%s\t%s" % (i, stream_ids[i], str(handles[i]))
                if handles[i] > 0:
                    horde_api.stream_close(stream_ids[i], handles[i])
        horde_api.session_close(SESSION_NAME)
        print "session closed."
    
def do_server():
    if (horde_api.session_accept(SESSION_NAME)):
        print "connected to client."
        n = horde_api.stream_accept_multiple(nstreams, stream_ids, handles)
        print "accepted:", n
        if (n > 0):
            for i in range(nstreams):
                print "%02d:\t%s\t%s" % (i, stream_ids[i], str(handles[i]))
                if handles[i] > 0:
                    horde_api.stream_close(stream_ids[i], handles[i])
        horde_api.session_close(SESSION_NAME)
        print "session closed."
            
if len(sys.argv) == 1:
    # server
    do_server()
elif len(sys.argv) == 2:
    # client
    do_client(sys.argv[1])
else:
    print "usage:", sys.argv[0], "<server address>"
